from emod_api import schema_to_class as s2c
import json

def HIV(
        camp,
        time_offset=0,
        disease= 'HIV',
        reps= -1,
        interval= 1,
        start_day=0,
        nodeIDs=[],
        event_name='HIV Incidence'):

    schema_path = camp.schema_path
    iv_name = "OutbreakIndividualTBorHIV"
    event = s2c.get_class_with_defaults( "CampaignEvent", schema_path )
    coordinator = s2c.get_class_with_defaults( "GroupInterventionDistributionEventCoordinatorHIV", schema_path )
    if coordinator is None:
        print( "s2c.get_class_with_defaults returned None. Maybe no schema.json was provided." )
        return ""
    intervention = s2c.get_class_with_defaults( iv_name, schema_path )

    event.Start_Day = float(start_day)
    #event.Event_Name = event_name
    coordinator.Time_Offset = time_offset
    coordinator.Number_Repetitions = reps
    coordinator.Timesteps_Between_Repetitions = interval

    event.Event_Coordinator_Config = coordinator
    coordinator.Intervention_Config = intervention
    intervention.Infection_Type = disease
    return event

def new_intervention_as_file( camp, filename=None ):
    campaign = {}
    campaign["Events"] = []
    campaign["Events"].append( HIV( camp ) )
    if filename is None:
        filename = "hiv.json"
    with open( filename, "w" ) as camp_file:
        json.dump( campaign, camp_file, sort_keys=True, indent=4 )
    return filename

